<template>
  <div class="relative">
    <div v-if="isFilterDialogActive" class="absolute right-0 top-full z-10">
      <div class="bg-white p-6 border border-grey-default rounded-md shadow-sm">
        <div class="mb-6">
          <t-span weight="bold" class="text-black-default">Time</t-span>
          <div class="flex items-center space-x-2 mt-2">
            <a-time-picker v-model="selectedStartTime" value-format="HH:mm:ss" />
            <a-time-picker v-model="selectedEndTime" value-format="HH:mm:ss" />
          </div>
        </div>
        <div class="mb-10">
          <t-span weight="bold" class="text-black-default">Date</t-span>
          <div class="flex items-center space-x-2 mt-2">
            <a-date-picker v-model="selectedDate" value-format="dddd, D MMMM YYYY" />
          </div>
        </div>
        <b-action-button @click="onSetTime">Set time</b-action-button>
      </div>
    </div>
    <a-icon
      :type="isFilterDialogActive ? 'close' : 'filter'"
      class="text-xl text-black-default cursor-pointer"
      @click="toggleFilter"
    />
  </div>
</template>

<script>
import { defineComponent } from '@nuxtjs/composition-api'
import TSpan from '~/components/shared/typography/Span'
import BActionButton from '~/components/shared/buttons/ActionButton'
import { useBuilding } from '~/store/building'

export default defineComponent({
  components: { BActionButton, TSpan },
  setup() {
    const store = useBuilding()
    return { store }
  },
  data() {
    return {
      isFilterDialogActive: false,
      selectedStartTime: this.store.currentStartTime,
      selectedEndTime: this.store.currentEndTime,
      selectedDate: this.store.currentDate,
    }
  },
  methods: {
    toggleFilter() {
      this.isFilterDialogActive = !this.isFilterDialogActive
    },
    openFilter() {
      this.isFilterDialogActive = true
    },
    closeFilter() {
      this.isFilterDialogActive = false
    },
    onSetTime() {
      if (!(this.selectedStartTime && this.selectedEndTime && this.selectedDate)) {
        return
      }

      this.store.fetchFloors(this.selectedDate, this.selectedStartTime, this.selectedEndTime)
      this.closeFilter()
    },
  },
})
</script>
